## parallel-hashmap 1.3.11+ds

=== debian/changelog ===
parallel-hashmap (1.3.11+ds-1) unstable; urgency=medium

  * New upstream version 1.3.11+ds

 -- Andrius Merkys <merkys@debian.org>  Wed, 26 Apr 2023 04:24:26 -0400

parallel-hashmap (1.3.8+ds-3) unstable; urgency=medium

  * Accept only semantic versioned version numbers in debian/watch.

 -- Andrius Merkys <merkys@debian.org>  Wed, 08 Mar 2023 02:10:23 -0500

parallel-hashmap (1.3.8+ds-2) unstable; urgency=medium

  * Mention that parts of parallel_hashmap/phmap_utils.h is licensed under
    BSL-1.0.

 -- Andrius Merkys <merkys@debian.org>  Mon, 27 Feb 2023 07:41:34 -0500

parallel-hashmap (1.3.8+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1021041)

 -- Andrius Merkys <merkys@debian.org>  Wed, 22 Feb 2023 02:32:26 -0500

=== debian/rules ===
#!/usr/bin/make -f

PHMAP_BUILD_TESTS = OFF
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	PHMAP_BUILD_TESTS = ON
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DPHMAP_BUILD_TESTS=$(PHMAP_BUILD_TESTS) -DPHMAP_GTEST_LIBS='gmock_main -lgmock -lgtest' -DPHMAP_MASTER_PROJECT=ON

execute_after_dh_auto_install:
	rm debian/libparallel-hashmap-dev/usr/include/parallel_hashmap/conanfile.py

override_dh_fixperms:
	find debian -name "*.cc" | xargs -r chmod -x
	dh_fixperms

## parallel-hashmap 1.3.12%2Bds

=== CMakeLists.txt ===
#[===================================================================[
    parallel-hashmap library by Gregory Popovitch

    CMake projects that wish to use this library may do
    something like :

    include(FetchContent)
    FetchContent_Declare(
        parallel-hashmap
        GIT_REPOSITORY https://github.com/greg7mdp/parallel-hashmap.git
        GIT_TAG        v1.3.8 # adjust tag/branch/commit as needed
    )
    FetchContent_MakeAvailable(parallel-hashmap)

    ...
    include_directories(${parallel-hashmap_SOURCE_DIR})

#]===================================================================]

cmake_minimum_required(VERSION 3.8)

list (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(DetectVersion)

cmake_policy(SET CMP0048 NEW)             ## set VERSION as documented by the project() command.
cmake_policy(SET CMP0076 NEW)             ## accept new policy

if(NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 11)            ## compile with C++11 support
endif()

if(NOT CMAKE_CXX_STANDARD_REQUIRED)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

if(NOT DEFINED PHMAP_MASTER_PROJECT)
    set(PHMAP_MASTER_PROJECT OFF)
    if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
        set(PHMAP_MASTER_PROJECT ON)
    endif()
endif()

project(phmap VERSION ${DETECTED_PHMAP_VERSION} LANGUAGES CXX)

## ----------------------------- options -----------------------------
option(PHMAP_INSTALL "Enable installation" ${PHMAP_MASTER_PROJECT})


set(PHMAP_DIR parallel_hashmap)
set(PHMAP_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap.h 
                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_base.h 
                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_bits.h 
                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_config.h
                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_dump.h 
                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_fwd_decl.h 
                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_utils.h 
                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/meminfo.h 
                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/btree.h)

include(helpers)

add_library(${PROJECT_NAME} INTERFACE)

target_sources(${PROJECT_NAME} INTERFACE ${PHMAP_HEADERS})

target_include_directories(
     ${PROJECT_NAME} INTERFACE
     $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
     $<INSTALL_INTERFACE:include>)

if(PHMAP_INSTALL)
    include(GNUInstallDirs)
    include(CMakePackageConfigHelpers)
    
    install(
        DIRECTORY ${PROJECT_SOURCE_DIR}/${PHMAP_DIR}/
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PHMAP_DIR})
    
    install(TARGETS ${PROJECT_NAME}
            EXPORT ${PROJECT_NAME}-targets)
    
    export(EXPORT ${PROJECT_NAME}-targets
           FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")
endif()

## ------------------------- building tests and examples -------------
option(PHMAP_BUILD_TESTS    "Whether or not to build the tests"    ${PHMAP_MASTER_PROJECT})
option(PHMAP_BUILD_EXAMPLES "Whether or not to build the examples" ${PHMAP_MASTER_PROJECT})

if(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
endif()

if (PHMAP_BUILD_TESTS OR PHMAP_BUILD_EXAMPLES)
    include_directories(${PROJECT_SOURCE_DIR})
endif()

if (PHMAP_BUILD_TESTS)

    if (NOT PHMAP_GTEST_LIBS)
        include(cmake/DownloadGTest.cmake)
    
        check_target(gtest)
        check_target(gtest_main)
        check_target(gmock)
        set(PHMAP_GTEST_LIBS gmock_main)
    endif()

    enable_testing()

    ## ---------------- regular hash maps ----------------------------
    phmap_cc_test(NAME container_memory SRCS "tests/container_memory_test.cc"
                  DEPS ${PHMAP_GTEST_LIBS})

    phmap_cc_test(NAME hash_policy_testing SRCS "tests/hash_policy_testing_test.cc"
                  DEPS ${PHMAP_GTEST_LIBS})

    phmap_cc_test(NAME node_hash_policy SRCS "tests/node_hash_policy_test.cc"
                  DEPS ${PHMAP_GTEST_LIBS})

    phmap_cc_test(NAME raw_hash_set SRCS "tests/raw_hash_set_test.cc"
                  DEPS ${PHMAP_GTEST_LIBS})

    phmap_cc_test(NAME raw_hash_set_allocator SRCS "tests/raw_hash_set_allocator_test.cc"
                  DEPS ${PHMAP_GTEST_LIBS})

    ## ---------------- regular hash maps ----------------------------
    phmap_cc_test(NAME flat_hash_set SRCS "tests/flat_hash_set_test.cc"
                  COPTS "-DUNORDERED_SET_CXX17" DEPS ${PHMAP_GTEST_LIBS})

    phmap_cc_test(NAME flat_hash_map SRCS "tests/flat_hash_map_test.cc"
                  DEPS ${PHMAP_GTEST_LIBS})

    phmap_cc_test(NAME node_hash_map SRCS "tests/node_hash_map_test.cc"
                  DEPS ${PHMAP_GTEST_LIBS})

    phmap_cc_test(NAME node_hash_set SRCS "tests/node_hash_set_test.cc"
                  COPTS "-DUNORDERED_SET_CXX17" DEPS  ${PHMAP_GTEST_LIBS})

    ## --------------- parallel hash maps -----------------------------------------------
    phmap_cc_test(NAME parallel_flat_hash_map SRCS "tests/parallel_flat_hash_map_test.cc"
                  COPTS "-DUNORDERED_MAP_CXX17" DEPS ${PHMAP_GTEST_LIBS})

    phmap_cc_test(NAME parallel_flat_hash_set SRCS "tests/parallel_flat_hash_set_test.cc"
                  COPTS "-DUNORDERED_SET_CXX17" DEPS ${PHMAP_GTEST_LIBS})

    phmap_cc_test(NAME parallel_node_hash_map SRCS "tests/parallel_node_hash_map_test.cc"
                  DEPS ${PHMAP_GTEST_LIBS})

    phmap_cc_test(NAME parallel_node_hash_set SRCS "tests/parallel_node_hash_set_test.cc"
                  COPTS "-DUNORDERED_SET_CXX17" DEPS  ${PHMAP_GTEST_LIBS})

    phmap_cc_test(NAME parallel_flat_hash_map_mutex SRCS "tests/parallel_flat_hash_map_mutex_test.cc"
                  COPTS "-DUNORDERED_MAP_CXX17" DEPS ${PHMAP_GTEST_LIBS})

    phmap_cc_test(NAME dump_load SRCS "tests/dump_load_test.cc"
                  COPTS "-DUNORDERED_MAP_CXX17" DEPS ${PHMAP_GTEST_LIBS})

    phmap_cc_test(NAME erase_if SRCS "tests/erase_if_test.cc"
                  COPTS "-DUNORDERED_MAP_CXX17" DEPS ${PHMAP_GTEST_LIBS})

    ## --------------- btree -----------------------------------------------
    phmap_cc_test(NAME btree SRCS "tests/btree_test.cc"
                  DEPS ${PHMAP_GTEST_LIBS})


endif()

if (PHMAP_BUILD_EXAMPLES)
    if(NOT MSVC)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -Wall -Wextra -Wcast-align -Wcast-qual -Wdisabled-optimization -Winit-self -Wlogical-op -Wmissing-include-dirs -Woverloaded-virtual -Wredundant-decls -Wshadow -Wstrict-null-sentinel  -Wswitch-default -Wno-unused")
        if (NOT CMAKE_COMPILER_IS_GNUCC OR CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5.0)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unknown-warning-option -Wno-gnu-zero-variadic-macro-arguments")
        endif()
    else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4 /Zc:__cplusplus")
    endif()

    set(THREADS_PREFER_PTHREAD_FLAG ON)
    find_package(Threads REQUIRED)

    add_executable(ex_allmaps examples/allmaps.cc phmap.natvis)
    add_executable(ex_basic examples/basic.cc phmap.natvis)
    add_executable(ex_bench examples/bench.cc phmap.natvis)
    add_executable(ex_emplace examples/emplace.cc phmap.natvis)
    if (MSVC)
        add_executable(ex_lazy_emplace_l examples/lazy_emplace_l.cc phmap.natvis)
    endif()
    add_executable(ex_serialize examples/serialize.cc phmap.natvis)
    #target_include_directories(ex_serialize PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../cereal/include>)
    add_executable(ex_hash_std examples/hash_std.cc phmap.natvis)
    add_executable(ex_hash_value examples/hash_value.cc phmap.natvis)
    add_executable(ex_hash examples/hash.cc phmap.natvis)
    add_executable(ex_two_files examples/f1.cc examples/f2.cc phmap.natvis)
    add_executable(ex_insert_bench examples/insert_bench.cc phmap.natvis)
    add_executable(ex_knucleotide examples/knucleotide.cc phmap.natvis)
    add_executable(ex_dump_load examples/dump_load.cc phmap.natvis)
    add_executable(ex_btree examples/btree.cc phmap.natvis)
    add_executable(ex_hash_bench examples/hash_bench.cc phmap.natvis)
    add_executable(ex_matt examples/matt.cc phmap.natvis)
    add_executable(ex_mt_word_counter examples/mt_word_counter.cc phmap.natvis)
    add_executable(ex_p_bench examples/p_bench.cc phmap.natvis)

    target_link_libraries(ex_knucleotide Threads::Threads)
    target_link_libraries(ex_bench Threads::Threads)
endif()

=== benchmark/Makefile ===
CXX=CL -EHsc -DNDEBUG -Fo$@ -O2
#CXX=CL -EHsc -g -debug -Zi  -Fo$@
#CXX=g++ -ggdb -O2 -lm -std=c++11 -DNDEBUG 

ABSEIL_LIBS=absl_bad_optional_access.lib absl_bad_variant_access.lib absl_base.lib absl_demangle_internal.lib absl_hash.lib absl_int128.lib absl_internal_bad_any_cast_impl.lib absl_internal_city.lib absl_internal_civil_time.lib absl_internal_debugging_internal.lib absl_internal_graphcycles_internal.lib absl_internal_hashtablez_sampler.lib absl_internal_malloc_internal.lib absl_internal_spinlock_wait.lib absl_internal_strings_internal.lib absl_internal_throw_delegate.lib absl_internal_time_zone.lib absl_optional.lib absl_raw_hash_set.lib absl_stacktrace.lib absl_strings.lib absl_symbolize.lib absl_synchronization.lib absl_time.lib

PROGS       = stl_unordered_map sparsepp phmap abseil_flat abseil_parallel_flat phmap_flat
BUILD_PROGS = $(addprefix build/,$(PROGS))
SIZE        = 100000000
ABSEIL      = ../../abseil-cpp
PHMAP_SRC   = ../parallel_hashmap

all: test

builddir: 
	@if [ ! -d build ]; then mkdir build; fi

build/stl_unordered_map: bench.cc Makefile
	$(CXX) -DSTL_UNORDERED -I.. bench.cc -o $@

build/sparsepp: bench.cc Makefile
	$(CXX) -DSPARSEPP -I.. -I../../sparsepp bench.cc -o $@

build/phmap: bench.cc Makefile $(PHMAP_SRC)/phmap.h
	$(CXX) -DPHMAP -I.. -I$(ABSEIL) bench.cc /MD -o $@ /link /LIBPATH:$(ABSEIL)/build/lib ${ABSEIL_LIBS}

build/phmap_flat: bench.cc Makefile $(PHMAP_SRC)/phmap.h
	$(CXX) -DPHMAP_FLAT -I.. bench.cc /MD -o $@ 

build/abseil_flat: bench.cc Makefile
	$(CXX) -DABSEIL_FLAT -I.. -I$(ABSEIL) bench.cc /MD -o $@ /link /LIBPATH:$(ABSEIL)/build/lib ${ABSEIL_LIBS}

build/abseil_parallel_flat: bench.cc Makefile
	$(CXX) -DABSEIL_PARALLEL_FLAT -I.. -I $(ABSEIL) bench.cc /MD -o $@ /link /LIBPATH:$(ABSEIL)/build/lib ${ABSEIL_LIBS}

build/emplace: emplace.cc Makefile $(PHMAP_SRC)/phmap.h
	$(CXX) -DABSEIL_FLAT -I.. -I$(ABSEIL) emplace.cc /MD -o $@ /link /LIBPATH:$(ABSEIL)/build/lib ${ABSEIL_LIBS}

progs:	$(BUILD_PROGS)

test: builddir progs
	-rm -f output
	#./build/stl_unordered_map $(SIZE) random >> output
	#./build/sparsepp    $(SIZE) random >> output
	./build/abseil_flat  $(SIZE) random >> output
	#./build/phmap_flat   $(SIZE) random >> output
	./build/phmap        $(SIZE) random >> output
	./build/abseil_parallel_flat $(SIZE) random >> output
	python make_chart_data.py < output

test_cust: 
	-rm -f output
	#./build/abseil_flat $(SIZE) random >> output
	#./build/sparsepp    $(SIZE) random >> output
	./build/abseil_parallel_flat_5 $(SIZE) random >> output
	./build/abseil_parallel_flat $(SIZE) random >> output
	python make_chart_data.py < output

chart:
	python make_chart_data.py < output

clean:
	-rm -fr output build

## parallel-hashmap 1.3.12+ds

=== html/Makefile ===
PANDOC        = stack exec pandoc -- 
MATHJAX       = "http://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"
FLAGS         = --standalone --toc --toc-depth=2 --mathjax=$(MATHJAX) --highlight-style pygments
PNG_IMAGES    = $(patsubst %.pdf,%.png,$(wildcard img/*.pdf))
IFORMAT       = -f gfm
FILTER        = includes.exe
FILTER_OPT    = --filter=${FILTER}  # includes.hs 

############################### html
STYLE         = css/style.css
TEMPLATE_HTML = template.html
HTML_OPT      = -c ${STYLE} --template ${TEMPLATE_HTML} -t html
PGTITLE       = --metadata pagetitle="The Parallel Hashmap" 

############################### pdf
TEMPLATE_TEX  = template.latex
TEX_OPT       = --template $(TEMPLATE_TEX) --pdf-engine=xelatex

############################### epub
EPUB_COVER    = --epub-cover-image=img/cover-kindle.jpg


SRC = parallel_hashmap.md

OBJ = $(SRC:.md=.html)

all: html

includes.exe: includes.hs
	stack exec ghc -- -o $@ -no-keep-hi-files -no-keep-o-files includes.hs

html: parallel_hashmap.md $(FILTER) ${TEMPLATE_HTML} ${STYLE}
	$(PANDOC) ${FILTER_OPT} ${IFORMAT} ${HTML_OPT} $(FLAGS) ${PGTITLE} -o ../index.html parallel_hashmap.md

%.pdf: %.md $(FILTER) ${TEMPLATE_TEX}
	$(PANDOC) ${FILTER_OPT} ${IFORMAT} ${TEX_OPT} $(FLAGS) -o $@ $<

pdf: $(FILTER) ${TEMPLATE_TEX} 
	rm -f parallel_hashmap.pdf; $(PANDOC) ${FILTER_OPT} ${IFORMAT} ${TEX_OPT} $(FLAGS) -o parallel_hashmap.pdf title.md $(SRC)

native: 
	$(PANDOC) -s -t native $(SRC)

native_filt: $(FILTER)
	$(PANDOC) ${FILTER_OPT} -s -t native $(SRC)

clean:
	-rm -f *.html *.pdf cppi.epub

=== debian/changelog ===
parallel-hashmap (1.3.12+ds-1) unstable; urgency=medium

  * New upstream version 1.3.12+ds
  * Refresh debian/copyright.
  * Refresh include_directories.patch.

 -- Andrius Merkys <merkys@debian.org>  Wed, 31 Jan 2024 02:02:06 -0500

=== debian/control ===
Source: parallel-hashmap
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Steffen Moeller <moeller@debian.org>,
 Andrius Merkys <merkys@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libgmock-dev <!nocheck>,
Standards-Version: 4.6.2
Homepage: https://github.com/greg7mdp/parallel-hashmap
Vcs-Browser: https://salsa.debian.org/science-team/parallel-hashmap
Vcs-Git: https://salsa.debian.org/science-team/parallel-hashmap.git

Package: libparallel-hashmap-dev
Section: libdevel
Architecture: all
Depends:
 ${misc:Depends},
Suggests:
 libjs-jquery,
 libjs-jquery-flot,
 libjs-jquery-mousewheel,
Description: header-only hash map implementation
 This repository aims to provide a set of excellent hash map
 implementations, as well as a btree alternative to std::map and std::set,
 with the following characteristics:
 .
  * Header only: nothing to build, just copy the parallel_hashmap directory
    to your project and you are good to go.
  * drop-in replacement for std::unordered_map, std::unordered_set,
    std::map and std::set
  * Compiler with C++11 support required, C++14 and C++17 APIs are provided
    (such as try_emplace)
  * Very efficient, significantly faster than your compiler's unordered
    map/set or Boost's, or than sparsepp
  * Memory friendly: low memory usage, although a little higher than
    sparsepp
  * Supports heterogeneous lookup
  * Easy to forward declare: just include phmap_fwd_decl.h in your header
    files to forward declare Parallel Hashmap containers [note: this does
    not work currently for hash maps with pointer keys]
  * Dump/load feature: when a flat hash map stores data that is
    std::trivially_copyable, the table can be dumped to disk and restored
    as a single array, very efficiently, and without requiring any hash
    computation. This is typically about 10 times faster than doing
    element-wise serialization to disk, but it will use 10% to 60% extra
    disk space. See examples/serialize.cc. (flat hash map/set only)
  * Tested on Windows (vs2015 & vs2017, vs2019, Intel compiler 18 and 19),
    linux (g++ 4.8.4, 5, 6, 7, 8, clang++ 3.9, 4.0, 5.0) and MacOS (g++
    and clang++) - click on travis and appveyor icons above for detailed
    test status.
  * Automatic support for boost's hash_value() method for providing the
    hash function (see examples/hash_value.h). Also default hash support
    for std::pair and std::tuple.

=== debian/rules ===
#!/usr/bin/make -f

PHMAP_BUILD_TESTS = OFF
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	PHMAP_BUILD_TESTS = ON
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DPHMAP_BUILD_TESTS=$(PHMAP_BUILD_TESTS) -DPHMAP_GTEST_LIBS='gmock_main -lgmock -lgtest' -DPHMAP_MASTER_PROJECT=ON

execute_before_dh_fixperms:
	find debian -name "*.cc" | xargs -r chmod -x

## parallel-hashmap 1.4.1%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
     FetchContent_Declare(
         parallel-hashmap
         GIT_REPOSITORY https://github.com/greg7mdp/parallel-hashmap.git
-        GIT_TAG        v1.3.8 # adjust tag/branch/commit as needed
+        GIT_TAG        v1.4.1 # adjust tag/branch/commit as needed
     )
     FetchContent_MakeAvailable(parallel-hashmap)
 
@@ -17,14 +17,11 @@
 
 #]===================================================================]
 
-cmake_minimum_required(VERSION 3.8)
+cmake_minimum_required(VERSION 3.13)
 
 list (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
 include(DetectVersion)
-
-cmake_policy(SET CMP0048 NEW)             ## set VERSION as documented by the project() command.
-cmake_policy(SET CMP0076 NEW)             ## accept new policy
 
 if(NOT CMAKE_CXX_STANDARD)
     set(CMAKE_CXX_STANDARD 11)            ## compile with C++11 support
@@ -48,14 +45,14 @@
 
 
 set(PHMAP_DIR parallel_hashmap)
-set(PHMAP_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap.h 
-                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_base.h 
-                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_bits.h 
+set(PHMAP_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap.h
+                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_base.h
+                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_bits.h
                   ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_config.h
-                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_dump.h 
-                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_fwd_decl.h 
-                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_utils.h 
-                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/meminfo.h 
+                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_dump.h
+                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_fwd_decl.h
+                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/phmap_utils.h
+                  ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/meminfo.h
                   ${CMAKE_CURRENT_SOURCE_DIR}/${PHMAP_DIR}/btree.h)
 
 include(helpers)
@@ -72,14 +69,14 @@
 if(PHMAP_INSTALL)
     include(GNUInstallDirs)
     include(CMakePackageConfigHelpers)
-    
+
     install(
         DIRECTORY ${PROJECT_SOURCE_DIR}/${PHMAP_DIR}/
         DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PHMAP_DIR})
-    
+
     install(TARGETS ${PROJECT_NAME}
             EXPORT ${PROJECT_NAME}-targets)
-    
+
     export(EXPORT ${PROJECT_NAME}-targets
            FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")
 endif()
@@ -89,7 +86,7 @@
 option(PHMAP_BUILD_EXAMPLES "Whether or not to build the examples" ${PHMAP_MASTER_PROJECT})
 
 if(MSVC)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
+    add_compile_options("$<$<COMPILE_LANGUAGE:CXX>:/bigobj>")
 endif()
 
 if (PHMAP_BUILD_TESTS OR PHMAP_BUILD_EXAMPLES)
@@ -100,7 +97,7 @@
 
     if (NOT PHMAP_GTEST_LIBS)
         include(cmake/DownloadGTest.cmake)
-    
+
         check_target(gtest)
         check_target(gtest_main)
         check_target(gmock)
@@ -169,12 +166,12 @@
 
 if (PHMAP_BUILD_EXAMPLES)
     if(NOT MSVC)
-        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -Wall -Wextra -Wcast-align -Wcast-qual -Wdisabled-optimization -Winit-self -Wlogical-op -Wmissing-include-dirs -Woverloaded-virtual -Wredundant-decls -Wshadow -Wstrict-null-sentinel  -Wswitch-default -Wno-unused")
+        add_compile_options("$<$<COMPILE_LANGUAGE:CXX>:-pedantic;-Wall;-Wextra;-Wcast-align;-Wcast-qual;-Wdisabled-optimization;-Winit-self;-Wlogical-op;-Wmissing-include-dirs;-Woverloaded-virtual;-Wredundant-decls;-Wshadow;-Wstrict-null-sentinel;-Wswitch-default;-Wno-unused>")
         if (NOT CMAKE_COMPILER_IS_GNUCC OR CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5.0)
-            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unknown-warning-option -Wno-gnu-zero-variadic-macro-arguments")
+            add_compile_options("$<$<COMPILE_LANGUAGE:CXX>:-Wno-unknown-warning-option;-Wno-gnu-zero-variadic-macro-arguments>")
         endif()
     else()
-        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4 /Zc:__cplusplus")
+        add_compile_options("$<$<COMPILE_LANGUAGE:CXX>:/W4;/Zc:__cplusplus>")
     endif()
 
     set(THREADS_PREFER_PTHREAD_FLAG ON)
@@ -202,7 +199,33 @@
     add_executable(ex_mt_word_counter examples/mt_word_counter.cc phmap.natvis)
     add_executable(ex_p_bench examples/p_bench.cc phmap.natvis)
 
+    #set(Boost_INCLUDE_DIR /home/greg/dev/boost_1_82_0) # if boost installed in non-standard location
+    set(Boost_USE_STATIC_LIBS OFF)
+    set(Boost_USE_MULTITHREADED ON)
+    set(Boost_USE_STATIC_RUNTIME OFF)
+
+    # llil4map.cc - see https://www.perlmonks.com/?node_id=11149643
+    # -------------------------------------------------------------
+    find_package(OpenMP)
+    find_package(Boost 1.70.0)
+    if (OPENMP_FOUND AND Boost_FOUND AND "cxx_std_20" IN_LIST CMAKE_CXX_COMPILE_FEATURES)
+       add_executable(ex_llil4map examples/llil4map.cc phmap.natvis)
+       target_include_directories(ex_llil4map PRIVATE ${Boost_INCLUDE_DIRS})
+       target_compile_features(ex_llil4map PUBLIC cxx_std_20)
+       find_package(TBB COMPONENTS tbb)
+       if (TBB_FOUND)
+           target_link_libraries(ex_llil4map PRIVATE TBB::tbb)
+       endif()
+       target_link_libraries(ex_llil4map PRIVATE OpenMP::OpenMP_CXX)
+       target_compile_options(ex_llil4map PRIVATE "${OpenMP_CXX_FLAGS}")
+
+       add_executable(ex_llil examples/llil.cc phmap.natvis)
+       target_include_directories(ex_llil PRIVATE ${Boost_INCLUDE_DIRS})
+       target_compile_features(ex_llil PUBLIC cxx_std_20)
+       
+       file(COPY examples/llil_utils DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
+    endif()
+
     target_link_libraries(ex_knucleotide Threads::Threads)
     target_link_libraries(ex_bench Threads::Threads)
 endif()
-

=== debian/changelog ===
parallel-hashmap (1.4.1+ds-2) unstable; urgency=medium

  * Do not build examples on i386 (Closes: #1103144)

 -- Andrius Merkys <merkys@debian.org>  Mon, 14 Apr 2025 09:05:37 -0400

parallel-hashmap (1.4.1+ds-1) unstable; urgency=medium

  * New upstream version 1.4.1+ds
  * Drop include_directories.patch: no longer needed.
  * Add missing Perl shebang to an example via patch.

 -- Andrius Merkys <merkys@debian.org>  Fri, 22 Nov 2024 02:24:49 -0500

## parallel-hashmap 1.4.1+ds

=== debian/changelog ===
parallel-hashmap (1.4.1+ds-3) unstable; urgency=medium

  * Build examples only on amd64 (Closes: #1113389)

 -- Andrius Merkys <merkys@debian.org>  Fri, 03 Oct 2025 02:41:06 -0400

parallel-hashmap (1.4.1+ds-3~exp1) experimental; urgency=medium

  * Move to arch:any.

 -- Andrius Merkys <merkys@debian.org>  Thu, 02 Oct 2025 10:56:54 -0400

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,9 @@
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
+ libboost-dev,
  libgmock-dev <!nocheck>,
+ libtbb-dev,
 Standards-Version: 4.6.2
 Homepage: https://github.com/greg7mdp/parallel-hashmap
 Vcs-Browser: https://salsa.debian.org/science-team/parallel-hashmap

=== debian/rules ===
#!/usr/bin/make -f

PHMAP_BUILD_TESTS = OFF
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	PHMAP_BUILD_TESTS = ON
endif

# Build examples only on amd64 (see #1103144 and #1113389)
PHMAP_BUILD_EXAMPLES = OFF
ifeq "$(DEB_HOST_ARCH)" "amd64"
       PHMAP_BUILD_EXAMPLES = ON
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DPHMAP_BUILD_TESTS=$(PHMAP_BUILD_TESTS) -DPHMAP_GTEST_LIBS='gmock_main -lgmock -lgtest' -DPHMAP_MASTER_PROJECT=ON -DPHMAP_BUILD_EXAMPLES=$(PHMAP_BUILD_EXAMPLES)

execute_before_dh_fixperms:
	find debian -name "*.cc" | xargs -r chmod -x

=== debian/watch ===
version=4
opts="repack,repacksuffix=+ds,dversionmangle=auto,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%parallel-hashmap-$1.tar.gz%" \
 https://github.com/greg7mdp/parallel-hashmap/tags (?:.*?/)?v?(\d+\.\d+\.\d+)\.tar\.gz
